#ifndef FD_Menu_h_
#define FD_Menu_h_
/* Header file generated with fdesign. */

/**** Callback routines ****/

extern void cb_mDatei(FL_OBJECT *, long);
extern void cb_mPreferences(FL_OBJECT *, long);
extern void cb_mTools(FL_OBJECT* ,long);

extern void cb_DUMMY(FL_OBJECT *,long);
extern void cb_cLayout(FL_OBJECT *, long);
extern void cb_cPart(FL_OBJECT *, long);
extern void cb_bDisplayGrid(FL_OBJECT *, long);
extern void cb_bUseGrid(FL_OBJECT *, long);
extern void cb_bZoomIn(FL_OBJECT *, long);
extern void cb_bZoomOut(FL_OBJECT *, long);
extern void cb_bAddElement(FL_OBJECT *, long);
extern void cb_bAddLine(FL_OBJECT *, long);
extern void cb_bAddBus(FL_OBJECT *, long);
extern void cb_bAddJunction(FL_OBJECT *, long);
extern void cb_bAddText(FL_OBJECT *, long);
extern void cb_bSelectObject(FL_OBJECT *, long);
extern void cb_bSelectArea(FL_OBJECT *, long);
extern void cb_bSelEdit(FL_OBJECT *, long);
extern void cb_bSelCut(FL_OBJECT *, long);
extern void cb_bSelCopy(FL_OBJECT *, long);
extern void cb_bSelPaste(FL_OBJECT *, long);
extern void cb_bSelMove(FL_OBJECT *, long);
extern void cb_bUnselect(FL_OBJECT *, long);
extern void cb_bAddSpecial(FL_OBJECT *, long);
extern void cb_mAddSpecial(FL_OBJECT *, long);


extern void cb_iEditRefNumber(FL_OBJECT *, long);
extern void cb_iValue(FL_OBJECT *, long);
extern void cb_bEditRefNumberPos(FL_OBJECT *, long);
extern void cb_bEditValuePos(FL_OBJECT *, long);
extern void cb_bEditColor(FL_OBJECT *, long);
extern void cb_bEditOK(FL_OBJECT *, long);


extern void cb_bShowOrigins(FL_OBJECT *, long);
extern void cb_bShowNames(FL_OBJECT *, long);
extern void cb_bShowValues(FL_OBJECT *, long);
extern void cb_bFreeText(FL_OBJECT *, long);
extern void cb_bMiniDraw(FL_OBJECT *, long);
extern void cb_bBusWidth(FL_OBJECT *, long);
extern void cb_cFreeTextSize(FL_OBJECT *, long);
extern void cb_cFreeTextStyle(FL_OBJECT *, long);
extern void cb_cBusWidth(FL_OBJECT *, long);
extern void cb_bDirtyDraw(FL_OBJECT *, long);
extern void cb_bConfLayoutOK(FL_OBJECT *, long);
extern void cb_bConfLayoutCancel(FL_OBJECT *, long);
extern void cb_bConfLayoutHelp(FL_OBJECT *, long);
extern void cb_cElemTextSize(FL_OBJECT *, long);
extern void cb_cElemTextStyle(FL_OBJECT *, long);
extern void cb_bKlickForFun(FL_OBJECT *, long);
extern void cb_bElectroShocks(FL_OBJECT *, long);
extern void cb_cPageSize(FL_OBJECT *, long);
extern void cb_cOrientation(FL_OBJECT *, long);



extern void cb_brColors(FL_OBJECT *, long);
extern void cb_bConfColor(FL_OBJECT *, long);
extern void cb_bDefaultColor(FL_OBJECT *, long);

extern void cb_brElementSelector(FL_OBJECT *, long);
extern void cb_iSearch(FL_OBJECT *, long);
extern void cb_bSearch(FL_OBJECT *, long);
extern void cb_bSelectorAdd(FL_OBJECT *, long);
extern void cb_bSearchNext(FL_OBJECT *, long);
extern void cb_bSelectorClose(FL_OBJECT *, long);

extern void cb_cPSPageSize(FL_OBJECT *, long);
extern void cb_cPSPageLayout(FL_OBJECT *, long);
extern void cb_iPSPageBorder(FL_OBJECT *, long);
extern void cb_iPSScaleX(FL_OBJECT *, long);
extern void cb_iPSScaleY(FL_OBJECT *, long);
extern void cb_iPSFreeWidth(FL_OBJECT *, long);
extern void cb_iPSFreeHeight(FL_OBJECT *, long);
extern void cb_iPSWireWidth(FL_OBJECT *, long);
extern void cb_iPSBusWidth(FL_OBJECT *, long);
extern void cb_iPSSizeTiny(FL_OBJECT *, long);
extern void cb_iPSSizeSmall(FL_OBJECT *, long);
extern void cb_iPSSizeNormal(FL_OBJECT *, long);
extern void cb_iPSSizeMedium(FL_OBJECT *, long);
extern void cb_iPSSizeLarge(FL_OBJECT *, long);
extern void cb_iPSSizeHuge(FL_OBJECT *, long);
extern void cb_iPSStyleNormal(FL_OBJECT *, long);
extern void cb_iPSStyleBold(FL_OBJECT *, long);
extern void cb_iPSStyleItalic(FL_OBJECT *, long);
extern void cb_iPSStyleFixed(FL_OBJECT *, long);
extern void cb_iPSFont(FL_OBJECT *, long);
extern void cb_bPSOK(FL_OBJECT *, long);
extern void cb_bPSCancel(FL_OBJECT *, long);
extern void cb_bPSHelp(FL_OBJECT *, long);

extern void cb_iPrintSpool(FL_OBJECT *, long);
extern void cb_iPrintPrinter(FL_OBJECT *, long);
extern void cb_iPrintViewer(FL_OBJECT *, long);
extern void cb_iPrintOutput(FL_OBJECT *, long);
extern void cb_bPrintPrint(FL_OBJECT *, long);
extern void cb_bPrintPreview(FL_OBJECT *, long);
extern void cb_bPrintCancel(FL_OBJECT *, long);


/**** Forms and Objects ****/

typedef struct {
	FL_FORM *Menu;
	FL_OBJECT *mDatei;
	FL_OBJECT *mPreferences;
	FL_OBJECT *mTools;
	void *vdata;
	long ldata;
} FD_Menu;

extern FD_Menu * create_form_Menu(void);
typedef struct {
	FL_FORM *Layout;
	FL_OBJECT *cLayout;
	FL_OBJECT *cPart;
	FL_OBJECT *bDisplayGrid;
	FL_OBJECT *bUseGrid;
	FL_OBJECT *bZoomIn;
	FL_OBJECT *bZoomOut;
	FL_OBJECT *bAddElement;
	FL_OBJECT *bAddLine;
	FL_OBJECT *bAddBus;
	FL_OBJECT *bAddJunction;
	FL_OBJECT *bAddText;
	FL_OBJECT *bSelectObject;
	FL_OBJECT *bSelectArea;
	FL_OBJECT *bSelEdit;
	FL_OBJECT *bSelCut;
	FL_OBJECT *bSelCopy;
	FL_OBJECT *bSelPaste;
	FL_OBJECT *bSelMove;
	FL_OBJECT *bUnselect;
	FL_OBJECT *tMouse1;
	FL_OBJECT *tMouse2;
	FL_OBJECT *tMouse3;
	FL_OBJECT *tMouseBack;
	FL_OBJECT *mAddSpecial;
	FL_OBJECT *bAddSpecial;
	
	void *vdata;
	long ldata;
} FD_Layout;

extern FD_Layout * create_form_Layout(void);


typedef struct {
	FL_FORM *Edit;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *iEditRefNumber;
	FL_OBJECT *iValue;
	FL_OBJECT *bEditRefNumberPos;
	FL_OBJECT *bEditValuePos;
	FL_OBJECT *bEditColor;
	FL_OBJECT *bEditOK;
} FD_Edit;

extern FD_Edit * create_form_Edit(void);



typedef struct {
	FL_FORM *ConfLayout;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *bShowOrigins;
	FL_OBJECT *bShowNames;
	FL_OBJECT *bShowValues;
	FL_OBJECT *bFreeText;
	FL_OBJECT *bMiniDraw;
	FL_OBJECT *bBusWidth;
	FL_OBJECT *cFreeTextSize;
	FL_OBJECT *cFreeTextStyle;
	FL_OBJECT *cBusWidth;
	FL_OBJECT *bDirtyDraw;
	FL_OBJECT *bConfLayoutOK;
	FL_OBJECT *bConfLayoutCancel;
	FL_OBJECT *bConfLayoutHelp;
	FL_OBJECT *cElemTextSize;
	FL_OBJECT *cElemTextStyle;
	FL_OBJECT *bKlickForFun;
	FL_OBJECT *bElectroShocks;
	FL_OBJECT *cPageSize;
	FL_OBJECT *cOrientation;
} FD_ConfLayout;

extern FD_ConfLayout * create_form_ConfLayout(void);
typedef struct {
	FL_FORM *ConfColors;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *brColors;
	FL_OBJECT *bConfColor;
	FL_OBJECT *bDefaultColor;
} FD_ConfColors;

extern FD_ConfColors * create_form_ConfColors(void);
typedef struct {
	FL_FORM *ElementBrowser;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *brElementSelector;
	FL_OBJECT *cElementPreview;
	FL_OBJECT *iSearch;
	FL_OBJECT *bSearch;
	FL_OBJECT *bSelectorAdd;
	FL_OBJECT *bSearchNext;
	FL_OBJECT *bSelectorClose;
} FD_ElementBrowser;

extern FD_ElementBrowser * create_form_ElementBrowser(void);

typedef struct {
	FL_FORM *ConfPrint;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *cPSPageSize;
	FL_OBJECT *cPSPageLayout;
	FL_OBJECT *iPSPageBorder;
	FL_OBJECT *iPSScaleX;
	FL_OBJECT *iPSScaleY;
	FL_OBJECT *iPSFreeWidth;
	FL_OBJECT *iPSFreeHeight;
	FL_OBJECT *iPSWireWidth;
	FL_OBJECT *iPSBusWidth;
	FL_OBJECT *iPSSizeTiny;
	FL_OBJECT *iPSSizeSmall;
	FL_OBJECT *iPSSizeNormal;
	FL_OBJECT *iPSSizeMedium;
	FL_OBJECT *iPSSizeLarge;
	FL_OBJECT *iPSSizeHuge;
	FL_OBJECT *iPSStyleNormal;
	FL_OBJECT *iPSStyleBold;
	FL_OBJECT *iPSStyleItalic;
	FL_OBJECT *iPSStyleFixed;
	FL_OBJECT *iPSFont;
	FL_OBJECT *bPSOK;
	FL_OBJECT *bPSCancel;
	FL_OBJECT *bPSHelp;
} FD_ConfPrint;

extern FD_ConfPrint * create_form_ConfPrint(void);


typedef struct {
	FL_FORM *Print;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *iPrintSpool;
	FL_OBJECT *iPrintPrinter;
	FL_OBJECT *iPrintViewer;
	FL_OBJECT *iPrintOutput;
	FL_OBJECT *bPrintPrint;
	FL_OBJECT *bPrintPreview;
	FL_OBJECT *bPrintCancel;
} FD_Print;

extern FD_Print * create_form_Print(void);



#endif /* FD_Menu_h_ */



#ifdef AS_MAIN
   FD_Menu *fd_Menu;
   FD_Layout *fd_Layout;
   FD_Edit *fd_Edit;
   FD_ConfLayout *fd_ConfLayout;
   FD_ConfColors *fd_ConfColors;
   FD_ElementBrowser *fd_ElementBrowser;
   FD_ConfPrint *fd_ConfPrint;
   FD_Print *fd_Print;
#else
   extern FD_Menu *fd_Menu;
   extern FD_Layout *fd_Layout;
   extern FD_Edit *fd_Edit;
   extern FD_ConfLayout *fd_ConfLayout;
   extern FD_ConfColors *fd_ConfColors;
   extern FD_ElementBrowser *fd_ElementBrowser;
   extern FD_ConfPrint *fd_ConfPrint;
   extern FD_Print *fd_Print;
   
#endif
