#include <forms.h>
#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "test.h"
#include "part.h"
#include "layout.h"
#include "element.h"
#include "diskops.h"
#include "tools.h"
#include "confcolor.h"
#include "conflayout.h"
#include "postscript.h"
#include "browser.h"







/* callbacks for form Menu */
void cb_mDatei(FL_OBJECT *ob, long data)
{
 char *FileName;

  switch(fl_get_menu(ob))
  {
    case 1:
    {
      AS_Element_DestroyElementList();
      AS_Element_DestroySelectList();
      if(LayoutData.ActElement!=NULL)
      {
        AS_Element_DestroyElement(LayoutData.ActElement);
        LayoutData.ActElement=NULL;
      }
      LayoutData.LastFound=NULL;
      LayoutData.BasicsMode = NOMODE;
      UnlightButtonsExceptThis(NULL);

      fl_show_form(fd_Layout->Layout,FL_PLACE_CENTERFREE,FL_FULLBORDER,"Layout");    

      AS_PartWin = fl_get_canvas_id(fd_Layout->cPart);
      fl_add_canvas_handler(fd_Layout->cPart, Expose, AS_PartWin_ExposeEvent, NULL);
      fl_add_canvas_handler(fd_Layout->cPart, MotionNotify, AS_PartWin_MotionEvent, NULL);
      fl_remove_selected_xevent(AS_PartWin,PointerMotionMask|PointerMotionHintMask);
      fl_addto_selected_xevent(AS_PartWin,OwnerGrabButtonMask);
        
      AS_LayoutWin = fl_get_canvas_id(fd_Layout->cLayout); 
      fl_add_canvas_handler(fd_Layout->cLayout, Expose, AS_LayoutWin_ExposeEvent, NULL);
      fl_add_canvas_handler(fd_Layout->cLayout, MotionNotify, AS_LayoutWin_MotionEvent, NULL);
      fl_add_canvas_handler(fd_Layout->cLayout, ButtonPress, AS_LayoutWin_ButtonEvent, NULL);
      fl_set_button(fd_Layout->bDisplayGrid,LayoutData.GridOn);
      fl_set_button(fd_Layout->bUseGrid,LayoutData.StayOnGrid);
      AS_LayoutWin_Repaint();
        
    } break;
    case 2:
    {
      fl_show_form(fd_Layout->Layout,FL_PLACE_CENTERFREE,FL_FULLBORDER,"Layout");    

      AS_PartWin = fl_get_canvas_id(fd_Layout->cPart);
      fl_add_canvas_handler(fd_Layout->cPart, Expose, AS_PartWin_ExposeEvent, NULL);
      fl_add_canvas_handler(fd_Layout->cPart, MotionNotify, AS_PartWin_MotionEvent, NULL);
      fl_remove_selected_xevent(AS_PartWin,PointerMotionMask|PointerMotionHintMask);
      fl_addto_selected_xevent(AS_PartWin,OwnerGrabButtonMask);
        
      AS_LayoutWin = fl_get_canvas_id(fd_Layout->cLayout); 
      fl_add_canvas_handler(fd_Layout->cLayout, Expose, AS_LayoutWin_ExposeEvent, NULL);
      fl_add_canvas_handler(fd_Layout->cLayout, MotionNotify, AS_LayoutWin_MotionEvent, NULL);
      fl_add_canvas_handler(fd_Layout->cLayout, ButtonPress, AS_LayoutWin_ButtonEvent, NULL);
      fl_set_button(fd_Layout->bDisplayGrid,LayoutData.GridOn);
      fl_set_button(fd_Layout->bUseGrid,LayoutData.StayOnGrid);


      FileName=(char *)fl_show_fselector("load this schematic:","./","*.sch",""); 
      if(FileName != NULL) 
      
      {
        AS_Element_DestroyElementList();
        AS_Element_DestroySelectList();
        if(LayoutData.ActElement!=NULL)
        {
          AS_Element_DestroyElement(LayoutData.ActElement);
          LayoutData.ActElement=NULL;
        }
        LayoutData.LastFound=NULL;
        LayoutData.BasicsMode = NOMODE;
        UnlightButtonsExceptThis(NULL);
          
        if( AS_Diskops_LoadAll(FileName) != 0)
          fl_show_messages("file does not exist!");
        else
          strcpy(LayoutData.FileName,FileName);
        AS_LayoutWin_Repaint(); 
      }
      
    } break;
    case 3:
    {
/* KEINE AHNUNG, WAS DAS SOLL ... ;-)  */
/*      if(AS_PartWin != 0)            */
      {
        fl_remove_canvas_handler(fd_Layout->cPart, Expose, NULL);
        fl_remove_canvas_handler(fd_Layout->cPart, MotionNotify, NULL);
        fl_remove_canvas_handler(fd_Layout->cLayout, Expose, NULL);
        fl_remove_canvas_handler(fd_Layout->cLayout, MotionNotify, NULL);
        fl_remove_canvas_handler(fd_Layout->cLayout, ButtonPress, NULL);
        fl_hide_form(fd_Layout->Layout);
        AS_Element_DestroyElementList();
        AS_Element_DestroySelectList();
        if(LayoutData.ActElement!=NULL)
        {
          AS_Element_DestroyElement(LayoutData.ActElement);
          LayoutData.ActElement=NULL;
        }
        LayoutData.LastFound=NULL;
        LayoutData.BasicsMode = NOMODE;
        UnlightButtonsExceptThis(NULL);
        AS_PartWin=0;
        AS_LayoutWin = 0;
      }
    } break;
    case 4:
    {
      if(SelectList != NULL)
        fl_show_messages("please, unselect elements before saving!");
      else
      {
        if(ElementList == NULL)
          fl_show_messages("saving an empty page? WHY?");
        else
        {
          FileName=(char *)fl_show_fselector("save this schematic:","./","*.sch",""); 
          if(FileName != NULL) 
          {
          
            if(AS_Tools_CheckFileExists(FileName)==1)
              if(fl_show_question("file exists, overwrite ?",2)==0)
                break;
              

            if(AS_Diskops_SaveAll(FileName) != 0)
              fl_show_messages("ERROR: schematic NOT saved!");
            else
            {
              fl_show_messages("schematic saved!");
              strcpy(LayoutData.FileName,FileName);
            }
          }
        }
      }
    } break;
    case 5:
    {
      AS_Print_InitMenu();
    }break;
    case 6:
    {
      if(fl_show_question("really quit ?",2)==0)
        break;
      AS_Element_DestroyElementList();
      AS_Element_DestroySelectList();
      AS_Element_DestroyCopyList();
      if(LayoutData.ActElement!=NULL)
      {
        AS_Element_DestroyElement(LayoutData.ActElement);
        LayoutData.ActElement=NULL;
      }
      fl_finish();
      exit (0);
    }
  }
}




void cb_mPreferences(FL_OBJECT *ob, long data)
{
  switch(fl_get_menu(ob))
  {

    /* Layout Config */
    case 1:
    {
      AS_ConfLayout_InitButtons();
    }break;

    case 2:
    {
      NotImplemented();
    }break;
    
    case 3:
    {
      AS_PS_InitMenu();
    } break;

    /* Color Config */
    case 4:
    {
      AS_ConfColor_InitBrowser();
    }break;
    
    /* save */
    case 5:
    {
      if(AS_Tools_SaveVars()==0)
        fl_show_messages("configuration saved");
      else
        fl_show_messages("ERROR: configuration NOT saved!\nno further information available...");
    }break;

  } /* end switch preferences */
}


void cb_mTools(FL_OBJECT *ob, long data)
{
  switch(fl_get_menu(ob))
  {
    case 1:
    {
      AS_Browser_InitMenu();
    } break;
  }

}


void cb_DUMMY(FL_OBJECT *ob, long data)
{
  /*
     During Editor Mode, all Layout-Callbacks (except Grid and Zoom Functions as well
     as Canvas-Handlers) are linked against this "dummy" callback
  */
}


void cb_cLayout(FL_OBJECT *ob, long data)
{
}


void cb_cPart(FL_OBJECT *ob, long data)
{
}


void cb_bDisplayGrid(FL_OBJECT *ob, long data)
{
  LayoutData.GridOn = (LayoutData.GridOn == 0) ? 1:0;
  AS_LayoutWin_Repaint();
}


void cb_bUseGrid(FL_OBJECT *ob, long data)
{
  LayoutData.StayOnGrid = (LayoutData.StayOnGrid == 0) ? 1:0;
}


void cb_bZoomIn(FL_OBJECT *ob, long data)
{
}


void cb_bZoomOut(FL_OBJECT *ob, long data)
{
}


void cb_bAddElement(FL_OBJECT *ob, long data)
{
  char *ElementName;
  int x,y;
  unsigned dummy;
  
  LayoutData.BasicsMode = ELEMENTMODE;

  ElementName=(char *)fl_show_simple_input("which element should be added ?","");

  if(LayoutData.ActElement != NULL)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement=NULL;
  }

  LayoutData.ActElement=AS_Element_CreateElement();
  if(AS_Element_LoadContents(ElementName,LayoutData.ActElement) != 0)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement=NULL;
    LayoutData.LastFound=NULL;
    LayoutData.BasicsMode=NOMODE;
    UnlightButtonsExceptThis(NULL);       /* unlight all */
    SetMouseButtonText("nothing","nothing","nothing");
  }
  else
  {
    fl_get_win_mouse(AS_LayoutWin,&x,&y,&dummy);
    LayoutData.ActElement->x = x;
    LayoutData.ActElement->x = y;
    LayoutData.ActElement->ElementType = etELEMENT;
    LayoutData.ActElement->next = NULL;
    AS_Layout_DrawElement(LayoutData.ActElement,Colors[SELECTCOLOR],AS_LayoutWin);
    UnlightButtonsExceptThis(fd_Layout->bAddElement);    /* not unlight addElement */
    SetMouseButtonText("place","flip","rotate");
  }
}

void cb_bAddLine(FL_OBJECT *ob, long data)
{
  struct sContent *tmp1;
  
  LayoutData.BasicsMode=LINEMODE;
  LayoutData.FirstPoint=0;

  if(LayoutData.ActElement != NULL)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement=NULL;
  }
  
  if( (LayoutData.ActElement=AS_Element_CreateElement()) == NULL)
  {
    LayoutData.BasicsMode = NOMODE;
    UnlightButtonsExceptThis(NULL);   
    LayoutData.LastFound=NULL;
    SetMouseButtonText("nothing","nothing","nothing");
    return;
  }  

  if( (tmp1=AS_Element_CreateContent()) == NULL)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement = NULL;
    LayoutData.BasicsMode = NOMODE;
    UnlightButtonsExceptThis(NULL);   
    LayoutData.LastFound=NULL;
    SetMouseButtonText("nothing","nothing","nothing");
    return;
  }

  
  LayoutData.ActElement->ElementType = etLINE;
  AS_Element_AddContentToElement(LayoutData.ActElement,tmp1);
  tmp1->Color=Colors[WIRECOLOR];
  LayoutData.FirstPoint=1;
  UnlightButtonsExceptThis(fd_Layout->bAddLine);
  SetMouseButtonText("place","nothing","abort");
}


void cb_bAddBus(FL_OBJECT *ob, long data)
{
  struct sContent *tmp1;
  
  LayoutData.BasicsMode=BUSMODE;
  LayoutData.FirstPoint=0;

  if(LayoutData.ActElement != NULL)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement=NULL;
  }
  
  if( (LayoutData.ActElement=AS_Element_CreateElement()) == NULL)
  {
    LayoutData.BasicsMode = NOMODE;
    UnlightButtonsExceptThis(NULL);   
    LayoutData.LastFound=NULL;
    SetMouseButtonText("nothing","nothing","nothing");
    return;
  }  

  if( (tmp1=AS_Element_CreateContent()) == NULL)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement = NULL;
    LayoutData.BasicsMode = NOMODE;
    UnlightButtonsExceptThis(NULL);   
    LayoutData.LastFound=NULL;
    SetMouseButtonText("nothing","nothing","nothing");
    return;
  }

  
  LayoutData.ActElement->ElementType = etBUS;
  AS_Element_AddContentToElement(LayoutData.ActElement,tmp1);
  tmp1->Color=Colors[WIRECOLOR];
  LayoutData.FirstPoint=1;
  UnlightButtonsExceptThis(fd_Layout->bAddBus);
  SetMouseButtonText("place","nothing","abort");

}

void cb_bAddJunction(FL_OBJECT *ob, long data)
{
  LayoutData.BasicsMode = JUNCTIONMODE;
  if(LayoutData.ActElement != NULL)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement=NULL;
  }

  if( (LayoutData.ActElement=AS_Element_CreateElement()) == NULL)
  {
    LayoutData.BasicsMode = NOMODE;
    LayoutData.LastFound=NULL;
    UnlightButtonsExceptThis(NULL);
    SetMouseButtonText("nothing","nothing","nothing");
    return;
  }  
  
  LayoutData.ActElement->ElementType = etJUNCTION;
  UnlightButtonsExceptThis(fd_Layout->bAddJunction);
  SetMouseButtonText("place","nothing","nothing");
 

}


void cb_bAddText(FL_OBJECT *ob, long data)
{
  char *Text;

  LayoutData.BasicsMode = TEXTMODE;
  if(LayoutData.ActElement != NULL)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement=NULL;
  }

  if( (LayoutData.ActElement=AS_Element_CreateElement()) == NULL)
  {
    LayoutData.BasicsMode = NOMODE;
    LayoutData.LastFound=NULL;
    UnlightButtonsExceptThis(NULL);
    SetMouseButtonText("nothing","nothing","nothing");
    return;
  }  
  LayoutData.ActElement->ElementType = etTEXT;
  Text=(char *)fl_show_simple_input("enter your text","");
  if(strlen(Text)>0)
  {
    AS_Tools_CutLF(Text,MAX_NAME);
    strcpy((char *)&LayoutData.ActElement->Name,Text);
    LayoutData.ActElement->RefNum=LayoutData.FreeTextSize;
    UnlightButtonsExceptThis(fd_Layout->bAddText);
    SetMouseButtonText("place","nothing","abort");
  }
  else
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement=NULL;
    UnlightButtonsExceptThis(NULL);
    SetMouseButtonText("nothing","nothing","nothing");
    LayoutData.BasicsMode = NOMODE;
  }
 
}


void cb_bAddSpecial(FL_OBJECT *ob, long data)
{
}


void cb_mAddSpecial(FL_OBJECT *ob, long data)
{
  fprintf(stderr,"CALLBACK \"Add Special\" says hello\n");
}



void cb_bSelectObject(FL_OBJECT *ob, long data)
{
  LayoutData.BasicsMode = SELECTMODE;
  LayoutData.LastFound=NULL;
  UnlightButtonsExceptThis(fd_Layout->bSelectObject);
  SetMouseButtonText("select","nothing","one back");
}


void cb_bSelectArea(FL_OBJECT *ob, long data)
{
  if(SelectList!=NULL)
  {
    AS_Element_DestroySelectList();
    AS_LayoutWin_Repaint();
  }
  LayoutData.BasicsMode = AREAMODE;
  LayoutData.FirstPoint=1;
  UnlightButtonsExceptThis(fd_Layout->bSelectArea);
  SetMouseButtonText("place","nothing","new");
}



void cb_bSelEdit(FL_OBJECT *ob, long data)
{
  char tmp[20];
  if((AS_Tools_CountSelectListEntries()==1)&&
     (SelectList->crossref->ElementType==etELEMENT))
  {

    fl_set_input(fd_Edit->iValue,(char *)&SelectList->crossref->Value);
    if(SelectList->crossref->RefNum!=0)
      sprintf((char *)&tmp,"%d",SelectList->crossref->RefNum);
    else
      strcpy((char *)&tmp,"");
    fl_set_input(fd_Edit->iEditRefNumber,(char *)&tmp);
    fl_show_form(fd_Edit->Edit,FL_PLACE_HOTSPOT,FL_FULLBORDER,"Editor");
    UnlightButtonsExceptThis(NULL);
    LayoutData.BasicsMode=EDITORMODE;
    AS_Tools_DisableCallbacks();
    fl_freeze_form(fd_Layout->Layout);
    fl_freeze_form(fd_Menu->Menu);
  }
}



void cb_bSelCut(FL_OBJECT *ob, long data)
{
  struct sElement *tmp1,*tmp2;
  if(SelectList!=NULL)
  {

    AS_Element_DestroyCopyList();

    tmp1=SelectList;
    while(tmp1!=NULL)
    {
      tmp2=AS_Element_CopyElement(tmp1->crossref);
      if(tmp2!=NULL)
        AS_Element_AddElementToCopyList(tmp2);
      tmp1=tmp1->next;
    }

    tmp1=SelectList;
    while(tmp1!=NULL)
    {
      AS_Element_RemoveElementFromElementList(tmp1->crossref);
      tmp1=tmp1->next;
    }
    AS_Element_DestroySelectList();
    LayoutData.LastFound=NULL;
    AS_LayoutWin_Repaint();
  }
}


void cb_bSelCopy(FL_OBJECT *ob, long data)
{
  struct sElement *tmp1,*tmp2;

  AS_Element_DestroyCopyList();

  if(SelectList!=NULL)
  {
    tmp1=SelectList;
    while(tmp1!=NULL)
    {
      tmp2=AS_Element_CopyElement(tmp1->crossref);
      if(tmp2!=NULL)
        AS_Element_AddElementToCopyList(tmp2);
      tmp1=tmp1->next;
    }
  }
}


void cb_bSelPaste(FL_OBJECT *ob, long data)
{ 
  struct sElement *tmp1,*tmp2,*tmp3;

  if((LayoutData.BasicsMode == MOVEMODE)||  /* this would corrupt our layout ;-) */
     (CopyList==NULL))                      /* this would be an useless operation */
    return;

  AS_Element_DestroySelectList();

  tmp1=CopyList;
  while(tmp1!=NULL)
  {
    tmp2=AS_Element_CopyElement(tmp1);            /* copy the element */
    if(tmp2!=NULL)
      AS_Element_AddElementToElementList(tmp2);
    if(!AS_Element_ElementInSelectList(tmp2))  /* no duplicate elements in selectlist allowed */
    {
      tmp3=AS_Element_CopyElement(tmp2);     
      if(tmp2!=NULL)
      {
        tmp3->crossref=tmp2;
        AS_Element_AddElementToSelectList(tmp3);
      }
    }
      
    tmp1=tmp1->next;
  }


  if(SelectList!=NULL)
  {
    LayoutData.BasicsMode=MOVEMODE;
    LayoutData.FirstPoint=1;
    SetMouseButtonText("place","nothing","nothing");
  }

}





void cb_bSelMove(FL_OBJECT *ob, long data)
{
  if(SelectList!=NULL)
  {
    LayoutData.BasicsMode=MOVEMODE;
    LayoutData.FirstPoint=1;
    SetMouseButtonText("place","nothing","nothing");
  }

}


void cb_bUnselect(FL_OBJECT *ob, long data)
{ 
  if(SelectList!=NULL)
  {
    AS_Element_DestroySelectList();
    AS_LayoutWin_Repaint();
  }
}




/* callbacks and freeobj handles for form Edit */
void cb_iEditRefNumber(FL_OBJECT *ob, long data)
{
}

void cb_iValue(FL_OBJECT *ob, long data)
{
}

void cb_bEditRefNumberPos(FL_OBJECT *ob, long data)
{
  char *RefNum;

  if(SelectList!=NULL)
  {
    RefNum=(char *)fl_get_input(fd_Edit->iEditRefNumber);
    SelectList->crossref->RefNum=atoi(RefNum);
    strcpy((char *)&SelectList->crossref->RefDisplay,\
           (char *)&SelectList->crossref->RefName);
    if((strlen(RefNum)>0)&&(SelectList->crossref->RefNum!=0))
      strncat((char *)&SelectList->crossref->RefDisplay,RefNum,\
               MAX_REFDISPLAY-strlen((char *)&SelectList->crossref->RefDisplay));
    else
      /* if the does not enter anything, the reference-name is not shown on screen */
      strcpy((char *)&SelectList->crossref->RefDisplay,"");  

    if(strlen(RefNum)>0)
    {
      LayoutData.BasicsMode=EDITORMODEREFNAMEPOS;
      fl_raise_form(fd_Layout->Layout);
      fl_activate_form(fd_Layout->Layout);
    }
    else
      LayoutData.BasicsMode=EDITORMODE;
  }

}

void cb_bEditValuePos(FL_OBJECT *ob, long data)
{
  char *Value;

  if(SelectList!=NULL)
  {
    Value=(char *)fl_get_input(fd_Edit->iValue);
    AS_Tools_CutLF(Value,MAX_VALUE);
    strcpy((char *)&SelectList->crossref->Value,Value);

    if(strlen(Value)>0)
    {
      LayoutData.BasicsMode=EDITORMODEVALUEPOS;
      fl_raise_form(fd_Layout->Layout);
      fl_activate_form(fd_Layout->Layout);
    }
    else
      LayoutData.BasicsMode=EDITORMODE;
  }
}


void cb_bEditColor(FL_OBJECT *ob, long data)
{
}

void cb_bEditOK(FL_OBJECT *ob, long data)
{
  char *Input;

  fl_hide_form(fd_Edit->Edit);
  AS_Tools_EnableCallbacks();
  fl_unfreeze_form(fd_Layout->Layout);
  fl_unfreeze_form(fd_Menu->Menu);

  if(SelectList!=NULL)
  {
    Input=(char *)fl_get_input(fd_Edit->iValue);
    AS_Tools_CutLF(Input,MAX_VALUE);
    strcpy((char *)&SelectList->crossref->Value,Input);

    Input=(char *)fl_get_input(fd_Edit->iEditRefNumber);
    SelectList->crossref->RefNum=atoi(Input);
    AS_Tools_CutLF(Input,MAX_REFDISPLAY);
    strcpy((char *)&SelectList->crossref->RefDisplay,\
           (char *)&SelectList->crossref->RefName);
    if((strlen(Input)>0)&&(SelectList->crossref->RefNum!=0))
      strncat((char *)&SelectList->crossref->RefDisplay,Input,\
               MAX_REFDISPLAY-strlen((char *)&SelectList->crossref->RefDisplay));
    else
      /* if the user does not enter anything (or zero), the reference-name
         is not shown on screen */
      strcpy((char *)&SelectList->crossref->RefDisplay,"");  

    SelectList->crossref->RefNum=atoi(Input);
  }

  /* This may cause a problem, because "cb_bSelectObject" is never leaved */
  /* But it depends on the xforms internals ... */
  cb_bSelectObject(NULL,0);
}


