#ifndef AS_MAIN
#define AS_MAIN
#endif


#include <stdio.h>
#include <stdlib.h>
#include <forms.h>
#include "tools.h"
#include "global.h"
#include "test.h"
#include "part.h"
#include "layout.h"
#include "element.h"


  const int TextStyle[5]=
  {
    0,        
    FL_NORMAL_STYLE,
    FL_BOLD_STYLE,
    FL_ITALIC_STYLE,
    FL_FIXED_STYLE
  };

  const int TextSize[7] =
  {
    0,      
    FL_TINY_SIZE,
    FL_SMALL_SIZE,
    FL_NORMAL_SIZE,
    FL_MEDIUM_SIZE,
    FL_LARGE_SIZE,
    FL_HUGE_SIZE
  };

  const int PageSize[MAXPAGESIZES][2] =
  {
    {   0,   0},       /* free */
    { 595, 842},       /* a4   */
    { 842,1191},       /* a3   */
    {1191,1684}        /* a2   */
  };


int main(int argc, char *argv[])
{
   AS_Tools_InitVars();
   AS_Tools_InitColors();

   fl_initialize(&argc, argv, 0, 0, 0);
   fd_Menu = create_form_Menu();
   fd_Layout = create_form_Layout();
   fd_Edit = create_form_Edit();
   fd_ConfLayout = create_form_ConfLayout();
   fd_ConfColors = create_form_ConfColors();
   fd_ElementBrowser = create_form_ElementBrowser();
   fd_ConfPrint = create_form_ConfPrint();
   fd_Print = create_form_Print();
   

   /* fill-in form initialization code */

   /* show the first form */
   fl_show_form(fd_Menu->Menu,FL_PLACE_CENTER,FL_FULLBORDER,"Menu");
   fl_do_forms();
   return 0;
}
