#include <forms.h>
#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "test.h"
#include "part.h"
#include "layout.h"
#include "element.h"
#include "diskops.h"
#include "tools.h"


int OrgColors[MAXCOLOR];


void AS_ConfColor_InitBrowser()
{
  int i;

  for(i=1;i<MAXCOLOR;i++)
    OrgColors[i]=Colors[i];

  fl_clear_browser(fd_ConfColors->brColors);
  fl_add_browser_line(fd_ConfColors->brColors,"Background");
  fl_add_browser_line(fd_ConfColors->brColors,"Grid");
  fl_add_browser_line(fd_ConfColors->brColors,"Wire");
  fl_add_browser_line(fd_ConfColors->brColors,"Bus");
  fl_add_browser_line(fd_ConfColors->brColors,"Junction");
  fl_add_browser_line(fd_ConfColors->brColors,"Text");
  fl_add_browser_line(fd_ConfColors->brColors,"Origins");
  fl_add_browser_line(fd_ConfColors->brColors,"Element");
  fl_add_browser_line(fd_ConfColors->brColors,"Element Names");
  fl_add_browser_line(fd_ConfColors->brColors,"Element Values");
  fl_add_browser_line(fd_ConfColors->brColors,"Select");
  fl_add_browser_line(fd_ConfColors->brColors,"Border");
  fl_show_form(fd_ConfColors->ConfColors,FL_PLACE_CENTER,FL_FULLBORDER,"Color-Config");

}


/* callbacks and freeobj handles for form ConfColors */
void cb_brColors(FL_OBJECT *ob, long data)
{
  int i;
  
  i=fl_get_browser(fd_ConfColors->brColors);
  Colors[i]=fl_show_colormap(Colors[i]);
  if(AS_LayoutWin!=0)
    AS_LayoutWin_Repaint();
}

void cb_bConfColor(FL_OBJECT *ob, long data)
{
  fl_hide_form(fd_ConfColors->ConfColors);
  if(AS_LayoutWin!=0)
    AS_LayoutWin_Repaint();
}

void cb_bDefaultColor(FL_OBJECT *ob, long data)
{
  int i;
  for(i=1;i<MAXCOLOR;i++)
    Colors[i]=OrgColors[i];
  fl_hide_form(fd_ConfColors->ConfColors);
  if(AS_LayoutWin!=0)
    AS_LayoutWin_Repaint();
  
}
 
