#define asLINE         0
#define asCIRCLE       1
#define asRECT         2
#define asNORMAL       0
#define asFILLED       1
#define asUP           0
#define asRIGHT        1
#define asDOWN         2
#define asLEFT         3
#define asNORMAL       0
#define asFLIPPED      1

#define etLINE         0
#define etELEMENT      1
#define etTEXT         2
#define etJUNCTION     3
#define etBUS          4
#define etDOTTLINE     5

#define ccR            0
#define ccC            1
#define ccL            2
#define ccD            3
#define ccV            4
#define ccU            5




extern struct sElement* AS_Element_CreateElement(void);
extern struct sContent* AS_Element_CreateContent(void);
extern int AS_Element_LoadContents(char *FileName, struct sElement *dieses);
extern int AS_Element_AddElementToElementList(struct sElement *dieses);
extern int AS_Element_DestroyElementList(void);
extern struct sElement* AS_Element_CopyElement(struct sElement *dieses);
extern int AS_Element_RotateElement(struct sElement *dieses);
extern int AS_Element_DestroyAllContentsOfElement(struct sElement *dieses);
extern int AS_Element_DestroyElement(struct sElement *dieses);
extern int AS_Element_DestroyContent(struct sContent *dieses);
extern int AS_Element_FlipElement(struct sElement *dieses);
extern int AS_Element_AddContentToElement(struct sElement *hierhin, struct sContent *dieses);
extern int AS_Element_RemoveElementFromElementList(struct sElement *dieses);

extern int AS_Element_AddElementToSelectList(struct sElement *dieses);
extern int AS_Element_AddElementToCopyList(struct sElement *dieses);
extern int AS_Element_RemoveElementFromSelectList(struct sElement *dieses);
extern int AS_Element_DestroySelectList(void);
extern int AS_Element_DestroyCopyList(void);
extern int AS_Element_ElementInSelectList(struct sElement *dieses);



