/* Form definition file generated with fdesign. */

#include <stdlib.h>
#include <forms.h>
#include "global.h"
#include "test.h"

FD_Menu *create_form_Menu(void)
{
  FL_OBJECT *obj;
  FD_Menu *fdui = (FD_Menu *) fl_calloc(1, sizeof(*fdui));

  fdui->Menu = fl_bgn_form(FL_NO_BOX, 280, 240);
  obj = fl_add_box(FL_UP_BOX,0,0,280,240,"");
  obj = fl_add_box(FL_UP_BOX,0,0,280,40,"");
  fdui->mDatei = obj = fl_add_menu(FL_PULLDOWN_MENU,10,10,70,20,"File");
    fl_set_menu(obj,"New|Open|Close|Save|Print%l|Quit");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_mDatei,0);
  fdui->mPreferences = obj = fl_add_menu(FL_PULLDOWN_MENU,80,10,70,20,"Preferences");
    fl_set_menu(obj,"Layout|Handling|Print|Colors%l|Save");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_mPreferences,0);
  fdui->mTools = obj = fl_add_menu(FL_PULLDOWN_MENU,150,10,70,20,"Tools");
    fl_set_menu(obj,"Element Browser");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_mTools,0);
  fl_end_form();

  return fdui;
}
/*---------------------------------------*/


static FL_PUP_ENTRY fdchoice_0[] =
{ 
    { "dotted line",	0,	"",	 FL_PUP_NONE},
    { "dashed line",	0,	"",	 FL_PUP_NONE},
    { "rectangle",	0,	"",	 FL_PUP_NONE},
    { "filled rectangle",	0,	"",	 FL_PUP_NONE},
    { "circle",	0,	"",	 FL_PUP_NONE},
    { "filled circle",	0,	"",	 FL_PUP_NONE},
    {0}
};



FD_Layout *create_form_Layout(void)
{
  FL_OBJECT *obj;
  FD_Layout *fdui = (FD_Layout *) fl_calloc(1, sizeof(*fdui));

  fdui->Layout = fl_bgn_form(FL_NO_BOX, 790, 580);
  obj = fl_add_box(FL_UP_BOX,0,0,790,580,"");
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,110,120,90,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,200,120,190,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,130,10,650,560,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,120,100,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  fdui->cLayout = obj = fl_add_canvas(FL_NORMAL_CANVAS,140,30,630,530,""); 
    fl_set_object_callback(obj,cb_cLayout,0);
  fdui->cPart = obj = fl_add_canvas(FL_NORMAL_CANVAS,20,30,100,70,"");
    fl_set_object_callback(obj,cb_cPart,0);
  obj = fl_add_text(FL_NORMAL_TEXT,20,10,100,20,"Page");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,140,10,630,20,"Layout");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  fdui->bDisplayGrid = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,130,100,20,"Show Grid");
    fl_set_object_callback(obj,cb_bDisplayGrid,0);
  fdui->bUseGrid = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,150,100,20,"Use Grid");
    fl_set_object_callback(obj,cb_bUseGrid,0);
  obj = fl_add_text(FL_NORMAL_TEXT,20,200,100,20,"Modes");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  fdui->bZoomIn = obj = fl_add_button(FL_NORMAL_BUTTON,20,170,50,20,"Zoom +");
    fl_set_button_shortcut(obj,"i",1);
    fl_set_object_callback(obj,cb_bZoomIn,0);
  fdui->bZoomOut = obj = fl_add_button(FL_NORMAL_BUTTON,70,170,50,20,"Zoom -");
    fl_set_button_shortcut(obj,"o",1);
    fl_set_object_callback(obj,cb_bZoomOut,0);
  fdui->bAddElement = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,220,100,20,"Add Element");
    fl_set_button_shortcut(obj,"a",1);
    fl_set_object_callback(obj,cb_bAddElement,0);
  fdui->bAddLine = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,240,100,20,"Add Wire");
    fl_set_button_shortcut(obj,"w",1);
    fl_set_object_callback(obj,cb_bAddLine,0);
  fdui->bAddBus = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,260,100,20,"Add Bus");
    fl_set_object_callback(obj,cb_bAddBus,0);
  fdui->bAddJunction = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,280,100,20,"Add Junction");
    fl_set_button_shortcut(obj,"j",1);
    fl_set_object_callback(obj,cb_bAddJunction,0);
  fdui->bAddText = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,300,100,20,"Add Text");
    fl_set_button_shortcut(obj,"t",1);
    fl_set_object_callback(obj,cb_bAddText,0);
  obj = fl_add_text(FL_NORMAL_TEXT,20,110,100,20,"Display");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);

  fdui->bSelectObject = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,320,100,20,"Select Objects");
    fl_set_button_shortcut(obj,"1",1);
    fl_set_object_callback(obj,cb_bSelectObject,0);
  fdui->bSelectArea = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,340,100,20,"Select Area");
    fl_set_button_shortcut(obj,"2",1);
    fl_set_object_callback(obj,cb_bSelectArea,0);


  fdui->bAddSpecial = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,360,30,20,"");
    fl_set_button_shortcut(obj,"s",1);
    fl_set_object_callback(obj,cb_bAddSpecial,0);


  fdui->mAddSpecial = obj = fl_add_choice(FL_NORMAL_CHOICE2,50,360,70,20,"");
    fl_set_object_callback(obj,cb_mAddSpecial,0);
   fl_set_choice_entries(obj, fdchoice_0);
   fl_set_choice(obj,1);



  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,390,120,90,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  obj = fl_add_text(FL_NORMAL_TEXT,20,390,100,20,"Selected");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  fdui->bSelEdit = obj = fl_add_button(FL_NORMAL_BUTTON,20,410,50,20,"Edit");
    fl_set_button_shortcut(obj,"e",1);
    fl_set_object_callback(obj,cb_bSelEdit,0);
  fdui->bSelCut = obj = fl_add_button(FL_NORMAL_BUTTON,70,450,50,20,"Cut");
    fl_set_button_shortcut(obj,"x",1);
    fl_set_object_callback(obj,cb_bSelCut,0);
  fdui->bSelCopy = obj = fl_add_button(FL_NORMAL_BUTTON,70,410,50,20,"Copy");
    fl_set_button_shortcut(obj,"c",1);
    fl_set_object_callback(obj,cb_bSelCopy,0);
  fdui->bSelPaste = obj = fl_add_button(FL_NORMAL_BUTTON,70,430,50,20,"Paste");
    fl_set_button_shortcut(obj,"v",1);
    fl_set_object_callback(obj,cb_bSelPaste,0);
  fdui->bSelMove = obj = fl_add_button(FL_NORMAL_BUTTON,20,430,50,20,"Move");
    fl_set_button_shortcut(obj,"m",1);
    fl_set_object_callback(obj,cb_bSelMove,0);
  fdui->bUnselect = obj = fl_add_button(FL_NORMAL_BUTTON,20,450,50,20,"Unselect");
    fl_set_button_shortcut(obj,"3",1);
    fl_set_object_callback(obj,cb_bUnselect,0);




  obj = fl_add_text(FL_NORMAL_TEXT,20,480,100,20,"Mouse");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_UP_FRAME,90,500,20,20,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  obj = fl_add_frame(FL_UP_FRAME,60,500,20,20,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  obj = fl_add_frame(FL_UP_FRAME,30,500,20,20,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  obj = fl_add_text(FL_NORMAL_TEXT,30,500,20,20,"1");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,60,500,20,20,"3");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,90,500,20,20,"2");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  fdui->tMouse1 = obj = fl_add_text(FL_NORMAL_TEXT,20,530,50,20,"Text");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->tMouse2 = obj = fl_add_text(FL_NORMAL_TEXT,70,530,50,20,"Text");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->tMouse3 = obj = fl_add_text(FL_NORMAL_TEXT,40,550,60,20,"Text");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->tMouseBack = obj = fl_add_frame(FL_ENGRAVED_FRAME,10,480,120,90,"");
    fl_set_object_color(obj,FL_BLACK,FL_COL1);
  fl_end_form();

  return fdui;
}
/*---------------------------------------*/

FD_Edit *create_form_Edit(void)
{
  FL_OBJECT *obj;
  FD_Edit *fdui = (FD_Edit *) fl_calloc(1, sizeof(*fdui));

  fdui->Edit = fl_bgn_form(FL_NO_BOX, 270, 220);
  obj = fl_add_box(FL_UP_BOX,0,0,270,220,"");
  obj = fl_add_text(FL_NORMAL_TEXT,70,10,120,20,"Element Editor");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,250,200,"");
  fdui->iEditRefNumber = obj = fl_add_input(FL_INT_INPUT,80,40,100,30,"Ref.-Number");
    fl_set_object_callback(obj,cb_iEditRefNumber,0);
  fdui->iValue = obj = fl_add_input(FL_NORMAL_INPUT,80,70,100,30,"Value");
    fl_set_object_callback(obj,cb_iValue,0);
  fdui->bEditRefNumberPos = obj = fl_add_button(FL_NORMAL_BUTTON,190,40,60,30,"Position");
    fl_set_object_callback(obj,cb_bEditRefNumberPos,0);
  fdui->bEditValuePos = obj = fl_add_button(FL_NORMAL_BUTTON,190,70,60,30,"Position");
    fl_set_object_callback(obj,cb_bEditValuePos,0);
  fdui->bEditColor = obj = fl_add_button(FL_NORMAL_BUTTON,190,120,60,30,"Color");
    fl_set_object_callback(obj,cb_bEditColor,0);
  fdui->bEditOK = obj = fl_add_button(FL_NORMAL_BUTTON,100,170,70,30,"OK");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bEditOK,0);
  fl_end_form();

  fdui->Edit->fdui = fdui;

  return fdui;
}


static FL_PUP_ENTRY fdchoice_TextSize78[] =
{ 
    /*  itemtext   callback  shortcut   mode */
    { "tiny",	0,	"",	 FL_PUP_NONE},
    { "small",	0,	"",	 FL_PUP_NONE},
    { "normal",	0,	"",	 FL_PUP_NONE},
    { "medium",	0,	"",	 FL_PUP_NONE},
    { "large",	0,	"",	 FL_PUP_NONE},
    { "huge",	0,	"",	 FL_PUP_NONE},
    {0}
};

static FL_PUP_ENTRY fdchoice_TextStyle79[] =
{ 
    /*  itemtext   callback  shortcut   mode */
    { "normal",	0,	"",	 FL_PUP_NONE},
    { "bold",	0,	"",	 FL_PUP_NONE},
    { "italic",	0,	"",	 FL_PUP_NONE},
    { "fixed",	0,	"",	 FL_PUP_NONE},
    {0}
};

static FL_PUP_ENTRY fdchoice_BusWidth80[] =
{ 
    /*  itemtext   callback  shortcut   mode */
    { "1",	0,	"",	 FL_PUP_NONE},
    { "2",	0,	"",	 FL_PUP_NONE},
    { "3",	0,	"",	 FL_PUP_NONE},
    { "4",	0,	"",	 FL_PUP_NONE},
    { "5",	0,	"",	 FL_PUP_NONE},
    {0}
};

static FL_PUP_ENTRY fdchoice_NaVaSize81[] =
{ 
    /*  itemtext   callback  shortcut   mode */
    { "tiny",	0,	"",	 FL_PUP_NONE},
    { "small",	0,	"",	 FL_PUP_NONE},
    { "normal",	0,	"",	 FL_PUP_NONE},
    { "medium",	0,	"",	 FL_PUP_NONE},
    { "large",	0,	"",	 FL_PUP_NONE},
    { "huge",	0,	"",	 FL_PUP_NONE},
    {0}
};

static FL_PUP_ENTRY fdchoice_NaVaStyle82[] =
{ 
    /*  itemtext   callback  shortcut   mode */
    { "normal",	0,	"",	 FL_PUP_NONE},
    { "bold",	0,	"",	 FL_PUP_NONE},
    { "italic",	0,	"",	 FL_PUP_NONE},
    { "fixed",	0,	"",	 FL_PUP_NONE},
    {0}
};

static FL_PUP_ENTRY fdchoice_PageSize7[] =
{ 
    /*  itemtext   callback  shortcut   mode */
    { "a4",	0,	"",	 FL_PUP_NONE},
    { "a3",	0,	"",	 FL_PUP_NONE},
    { "a2",	0,	"",	 FL_PUP_NONE},
    {0}
};

static FL_PUP_ENTRY fdchoice_Orientation8[] =
{ 
    /*  itemtext   callback  shortcut   mode */
    { "portrait",	0,	"",	 FL_PUP_NONE},
    { "landscape",	0,	"",	 FL_PUP_NONE},
    {0}
};



FD_ConfLayout *create_form_ConfLayout(void)
{
  FL_OBJECT *obj;
  FD_ConfLayout *fdui = (FD_ConfLayout *) fl_calloc(1, sizeof(*fdui));

  fdui->ConfLayout = fl_bgn_form(FL_NO_BOX, 300, 280);
  obj = fl_add_box(FL_UP_BOX,0,0,300,280,"");
  obj = fl_add_text(FL_NORMAL_TEXT,160,160,120,20,"Other Stupid Things");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,150,160,140,70,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,160,120,20,"Sheet Size");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,160,140,70,"");
  obj = fl_add_text(FL_NORMAL_TEXT,160,10,120,20,"Sizes");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,150,10,140,150,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,10,120,20,"Display");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,140,150,"");
  fdui->bShowOrigins = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,30,120,20,"Show Origins");
    fl_set_object_callback(obj,cb_bShowOrigins,0);
  fdui->bShowNames = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,50,120,20,"Show Names");
    fl_set_object_callback(obj,cb_bShowNames,0);
  fdui->bShowValues = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,70,120,20,"Show Values");
    fl_set_object_callback(obj,cb_bShowValues,0);
  fdui->bFreeText = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,90,120,20,"Show Free Text");
    fl_set_object_callback(obj,cb_bFreeText,0);
  fdui->bMiniDraw = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,110,120,20,"Mini Scroll Draw");
    fl_set_object_callback(obj,cb_bMiniDraw,0);
  fdui->bKlickForFun = obj = fl_add_lightbutton(FL_PUSH_BUTTON,20,130,120,20,"klick for fun");
    fl_set_object_callback(obj,cb_bKlickForFun,0);
  fdui->bBusWidth = obj = fl_add_lightbutton(FL_PUSH_BUTTON,160,50,120,20,"Use Bus Width");
    fl_set_object_callback(obj,cb_bBusWidth,0);
  fdui->cFreeTextSize = obj = fl_add_choice(FL_NORMAL_CHOICE2,210,70,70,20,"Text Size");
    fl_set_object_callback(obj,cb_cFreeTextSize,0);
   fl_set_choice_entries(obj, fdchoice_TextSize78);
   fl_set_choice(obj,3);
  fdui->cFreeTextStyle = obj = fl_add_choice(FL_NORMAL_CHOICE2,210,90,70,20,"Text Style");
    fl_set_object_callback(obj,cb_cFreeTextStyle,0);
   fl_set_choice_entries(obj, fdchoice_TextStyle79);
   fl_set_choice(obj,1);
  fdui->cBusWidth = obj = fl_add_choice(FL_NORMAL_CHOICE2,210,30,70,20,"Bus Width");
    fl_set_object_callback(obj,cb_cBusWidth,0);
   fl_set_choice_entries(obj, fdchoice_BusWidth80);
   fl_set_choice(obj,3);
  fdui->bDirtyDraw = obj = fl_add_lightbutton(FL_PUSH_BUTTON,160,180,120,20,"Dirty Draw");
    fl_set_object_callback(obj,cb_bDirtyDraw,0);
  fdui->bElectroShocks = obj = fl_add_lightbutton(FL_PUSH_BUTTON,160,200,120,20,"Electroshocks");
    fl_set_object_callback(obj,cb_bElectroShocks,0);
  fdui->bConfLayoutOK = obj = fl_add_button(FL_NORMAL_BUTTON,20,240,80,30,":-)");
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bConfLayoutOK,0);
  fdui->bConfLayoutCancel = obj = fl_add_button(FL_NORMAL_BUTTON,110,240,80,30,"ups...");
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bConfLayoutCancel,0);
  fdui->bConfLayoutHelp = obj = fl_add_button(FL_NORMAL_BUTTON,200,240,80,30,"?");
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bConfLayoutHelp,0);
  fdui->cElemTextSize = obj = fl_add_choice(FL_NORMAL_CHOICE2,210,110,70,20,"Na,Va Size");
    fl_set_object_callback(obj,cb_cElemTextSize,0);
   fl_set_choice_entries(obj, fdchoice_NaVaSize81);
   fl_set_choice(obj,3);
  fdui->cElemTextStyle = obj = fl_add_choice(FL_NORMAL_CHOICE2,210,130,70,20,"Na,Va Style");
    fl_set_object_callback(obj,cb_cElemTextStyle,0);
   fl_set_choice_entries(obj, fdchoice_NaVaStyle82);
   fl_set_choice(obj,1);
  fdui->cPageSize = obj = fl_add_choice(FL_NORMAL_CHOICE2,70,180,70,20,"Page Size");
    fl_set_object_callback(obj,cb_cPageSize,0);
   fl_set_choice_entries(obj, fdchoice_PageSize7);
   fl_set_choice(obj,1);
  fdui->cOrientation = obj = fl_add_choice(FL_NORMAL_CHOICE2,70,200,70,20,"Orientation");
    fl_set_object_callback(obj,cb_cOrientation,0);
   fl_set_choice_entries(obj, fdchoice_Orientation8);
   fl_set_choice(obj,1);

  fl_end_form();

  fdui->ConfLayout->fdui = fdui;

  return fdui;
}
/*---------------------------------------*/

FD_ConfColors *create_form_ConfColors(void)
{
  FL_OBJECT *obj;
  FD_ConfColors *fdui = (FD_ConfColors *) fl_calloc(1, sizeof(*fdui));

  fdui->ConfColors = fl_bgn_form(FL_NO_BOX, 300, 150);
  obj = fl_add_box(FL_UP_BOX,0,0,300,150,"");
  obj = fl_add_text(FL_NORMAL_TEXT,30,10,160,20,"Colors");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,200,130,"");
  fdui->brColors = obj = fl_add_browser(FL_SELECT_BROWSER,20,30,180,100,"");
    fl_set_object_callback(obj,cb_brColors,0);
  fdui->bConfColor = obj = fl_add_button(FL_NORMAL_BUTTON,220,110,70,30,"OK");
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bConfColor,0);
  fdui->bDefaultColor = obj = fl_add_button(FL_NORMAL_BUTTON,220,80,70,30,"Cancel");
    fl_set_object_callback(obj,cb_bDefaultColor,0);
  fl_end_form();

  fdui->ConfColors->fdui = fdui;

  return fdui;
}
/*---------------------------------------*/

FD_ElementBrowser *create_form_ElementBrowser(void)
{
  FL_OBJECT *obj;
  FD_ElementBrowser *fdui = (FD_ElementBrowser *) fl_calloc(1, sizeof(*fdui));

  fdui->ElementBrowser = fl_bgn_form(FL_NO_BOX, 340, 500);
  obj = fl_add_box(FL_UP_BOX,0,0,340,500,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,210,290,20,"Preview");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,210,320,200,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,10,300,20,"Element Selector");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,320,200,"");
  fdui->brElementSelector = obj = fl_add_browser(FL_SELECT_BROWSER,20,40,300,160,"");
    fl_set_object_callback(obj,cb_brElementSelector,0);
  fdui->cElementPreview = obj = fl_add_canvas(FL_NORMAL_CANVAS,20,230,300,170,"");
  fdui->iSearch = obj = fl_add_input(FL_NORMAL_INPUT,10,420,160,30,"");
    fl_set_object_callback(obj,cb_iSearch,0);
  fdui->bSearch = obj = fl_add_button(FL_NORMAL_BUTTON,10,460,80,30,"Search");
    fl_set_object_callback(obj,cb_bSearch,0);
  fdui->bSelectorAdd = obj = fl_add_button(FL_NORMAL_BUTTON,250,460,80,30,"Add");
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bSelectorAdd,0);
  fdui->bSearchNext = obj = fl_add_button(FL_NORMAL_BUTTON,90,460,80,30,"Next");
    fl_set_object_callback(obj,cb_bSearchNext,0);
  fdui->bSelectorClose = obj = fl_add_button(FL_NORMAL_BUTTON,250,420,80,30,"Close");
    fl_set_object_callback(obj,cb_bSelectorClose,0);
  fl_end_form();

  fdui->ElementBrowser->fdui = fdui;

  return fdui;
}
/*---------------------------------------*/

/*
static FL_PUP_ENTRY fdchoice_PageSize59[] =
{ 
    { "free",	0,	"",	 FL_PUP_NONE},
    { "a4",	0,	"",	 FL_PUP_NONE},
    { "a3",	0,	"",	 FL_PUP_NONE},
    { "a2",	0,	"",	 FL_PUP_NONE},
    {0}
};

static FL_PUP_ENTRY fdchoice_PageLayout60[] =
{ 
    { "portrait",	0,	"",	 FL_PUP_NONE},
    { "landscape",	0,	"",	 FL_PUP_NONE},
    {0}
};
*/

static FL_PUP_ENTRY fdchoice_PageSize59[] =
{ 
    { "disabled, use Layout-Settings!",	0,	"",	 FL_PUP_NONE},
    {0}
};

static FL_PUP_ENTRY fdchoice_PageLayout60[] =
{ 
    { "disabled, use Layout-Settings!",	0,	"",	 FL_PUP_NONE},
    {0}
};



FD_ConfPrint *create_form_ConfPrint(void)
{
  FL_OBJECT *obj;
  FD_ConfPrint *fdui = (FD_ConfPrint *) fl_calloc(1, sizeof(*fdui));

  fdui->ConfPrint = fl_bgn_form(FL_NO_BOX, 340, 380);
  obj = fl_add_box(FL_UP_BOX,0,0,340,380,"");
  obj = fl_add_text(FL_NORMAL_TEXT,180,10,140,20,"Layout Options");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,20,180,300,20,"Text Mappings");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,180,320,150,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,10,140,20,"Page Settings");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,160,170,"");
  fdui->cPSPageSize = obj = fl_add_choice(FL_NORMAL_CHOICE2,80,30,80,20,"Page Size ");
    fl_set_object_callback(obj,cb_cPSPageSize,0);
   fl_set_choice_entries(obj, fdchoice_PageSize59);
   fl_set_choice(obj,1);
  fdui->cPSPageLayout = obj = fl_add_choice(FL_NORMAL_CHOICE2,80,50,80,20,"Page Layout ");
    fl_set_object_callback(obj,cb_cPSPageLayout,0);
   fl_set_choice_entries(obj, fdchoice_PageLayout60);
   fl_set_choice(obj,1);
  fdui->iPSPageBorder = obj = fl_add_input(FL_INT_INPUT,80,70,80,20,"Page Border ");
    fl_set_object_callback(obj,cb_iPSPageBorder,0);
  fdui->iPSScaleX = obj = fl_add_input(FL_INT_INPUT,80,90,80,20,"Scale X ");
    fl_set_object_callback(obj,cb_iPSScaleX,0);
  fdui->iPSScaleY = obj = fl_add_input(FL_INT_INPUT,80,110,80,20,"Scale Y ");
    fl_set_object_callback(obj,cb_iPSScaleY,0);
  fdui->iPSFreeWidth = obj = fl_add_input(FL_INT_INPUT,80,130,80,20,"Free Width ");
    fl_set_object_callback(obj,cb_iPSFreeWidth,0);
  fdui->iPSFreeHeight = obj = fl_add_input(FL_INT_INPUT,80,150,80,20,"Free Height ");
    fl_set_object_callback(obj,cb_iPSFreeHeight,0);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,170,10,160,170,"");
  fdui->iPSWireWidth = obj = fl_add_input(FL_INT_INPUT,240,50,80,20,"Wire Width ");
    fl_set_object_callback(obj,cb_iPSWireWidth,0);
  fdui->iPSBusWidth = obj = fl_add_input(FL_INT_INPUT,240,70,80,20,"Bus Width ");
    fl_set_object_callback(obj,cb_iPSBusWidth,0);
  fdui->iPSSizeTiny = obj = fl_add_input(FL_INT_INPUT,80,200,80,20,"Size tiny ");
    fl_set_object_callback(obj,cb_iPSSizeTiny,0);
  fdui->iPSSizeSmall = obj = fl_add_input(FL_INT_INPUT,80,220,80,20,"Size small ");
    fl_set_object_callback(obj,cb_iPSSizeSmall,0);
  fdui->iPSSizeNormal = obj = fl_add_input(FL_INT_INPUT,80,240,80,20,"Size normal ");
    fl_set_object_callback(obj,cb_iPSSizeNormal,0);
  fdui->iPSSizeMedium = obj = fl_add_input(FL_INT_INPUT,80,260,80,20,"Size medium ");
    fl_set_object_callback(obj,cb_iPSSizeMedium,0);
  fdui->iPSSizeLarge = obj = fl_add_input(FL_INT_INPUT,80,280,80,20,"Size large ");
    fl_set_object_callback(obj,cb_iPSSizeLarge,0);
  fdui->iPSSizeHuge = obj = fl_add_input(FL_INT_INPUT,80,300,80,20,"Size huge ");
    fl_set_object_callback(obj,cb_iPSSizeHuge,0);
  fdui->iPSStyleNormal = obj = fl_add_input(FL_NORMAL_INPUT,240,200,80,20,"Style normal ");
    fl_set_object_callback(obj,cb_iPSStyleNormal,0);
  fdui->iPSStyleBold = obj = fl_add_input(FL_NORMAL_INPUT,240,220,80,20,"Style bold ");
    fl_set_object_callback(obj,cb_iPSStyleBold,0);
  fdui->iPSStyleItalic = obj = fl_add_input(FL_NORMAL_INPUT,240,240,80,20,"Style italic");
    fl_set_object_callback(obj,cb_iPSStyleItalic,0);
  fdui->iPSStyleFixed = obj = fl_add_input(FL_NORMAL_INPUT,240,260,80,20,"Size fixed ");
    fl_set_object_callback(obj,cb_iPSStyleFixed,0);
  fdui->iPSFont = obj = fl_add_input(FL_NORMAL_INPUT,240,300,80,20,"Font Type ");
    fl_set_object_callback(obj,cb_iPSFont,0);
  fdui->bPSOK = obj = fl_add_button(FL_NORMAL_BUTTON,20,340,80,30,"happy");
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bPSOK,0);
  fdui->bPSCancel = obj = fl_add_button(FL_NORMAL_BUTTON,130,340,80,30,"sh*t");
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bPSCancel,0);
  fdui->bPSHelp = obj = fl_add_button(FL_NORMAL_BUTTON,240,340,80,30,"what?");
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bPSHelp,0);
  obj = fl_add_text(FL_NORMAL_TEXT,180,30,140,20,"Wire and Bus Width in 1/10th Pts.!");
    fl_set_object_lsize(obj,FL_TINY_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->ConfPrint->fdui = fdui;

  return fdui;
}


FD_Print *create_form_Print(void)
{
  FL_OBJECT *obj;
  FD_Print *fdui = (FD_Print *) fl_calloc(1, sizeof(*fdui));

  fdui->Print = fl_bgn_form(FL_NO_BOX, 340, 170);
  obj = fl_add_box(FL_UP_BOX,0,0,340,170,"");
  obj = fl_add_text(FL_NORMAL_TEXT,180,10,140,20,"File");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,20,10,140,20,"Printer");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,10,10,160,110,"");
  fdui->iPrintSpool = obj = fl_add_input(FL_NORMAL_INPUT,80,30,80,20,"spooling cmd");
    fl_set_object_callback(obj,cb_iPrintSpool,0);
  fdui->iPrintPrinter = obj = fl_add_input(FL_NORMAL_INPUT,80,50,80,20,"printer (-P)");
    fl_set_object_callback(obj,cb_iPrintPrinter,0);
  obj = fl_add_frame(FL_ENGRAVED_FRAME,170,10,160,110,"");
  fdui->iPrintViewer = obj = fl_add_input(FL_NORMAL_INPUT,240,30,80,20,"ps-viewer");
    fl_set_object_callback(obj,cb_iPrintViewer,0);
  fdui->iPrintOutput = obj = fl_add_input(FL_NORMAL_INPUT,240,50,80,20,"output file");
    fl_set_object_callback(obj,cb_iPrintOutput,0);
  fdui->bPrintPrint = obj = fl_add_button(FL_NORMAL_BUTTON,50,80,80,30,"PRINT");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bPrintPrint,0);
  fdui->bPrintPreview = obj = fl_add_button(FL_NORMAL_BUTTON,210,80,80,30,"FILE");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bPrintPreview,0);
  fdui->bPrintCancel = obj = fl_add_button(FL_NORMAL_BUTTON,130,130,80,30,"close");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,cb_bPrintCancel,0);
  fl_end_form();

  fdui->Print->fdui = fdui;

  return fdui;
}

